package org.landis.jlyrics;

//{{{ imports
import java.io.*;
import java.util.*;
import javax.swing.DefaultListModel;
import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.landis.jlyrics.song.*; //}}}

public class FileIO {
	//{{{ variables
	File xmlFile = new File("./songs.xml"); //}}}
	
	//{{{ xmlRead
	SongList xmlRead(File xmlFile) {
		Document doc;
		org.landis.jlyrics.song.SongList data = new SongList();
		try {
			SAXBuilder builder = new SAXBuilder(false);
			doc = builder.build(xmlFile);
			
			Element root = doc.getRootElement();
			
			List songs = root.getChildren("song");
			Iterator i = songs.iterator();
			while (i.hasNext()) {
				Element currentSong = (Element) i.next();
				org.landis.jlyrics.song.Song songIn = new Song();
				songIn.setTitle(currentSong.getAttribute("title").getValue());
				songIn.setArtist(currentSong.getAttribute("artist").getValue());
				songIn.setLyrics(currentSong.getText());
				data.add(songIn);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return data;
	} //}}}
	
	//{{{ xmlWrite
	void xmlWrite(File xmlFile, List data, boolean dtd) {
		Element root = new Element("Collection");
		
		Iterator iter = data.iterator();
		while (iter.hasNext()) {
			Song currentSong = (Song) iter.next();
			Element song = new Element("song");
			song.setAttribute("title", currentSong.getTitle());
			song.setAttribute("artist", currentSong.getArtist());
			song.setText(currentSong.getLyrics());
			root.addContent(song);
		}
		Document doc = new Document(root);
		if (dtd)
			doc.setDocType(new DocType("collection", "./songs.dtd"));
		try {
			FileOutputStream out = new FileOutputStream(xmlFile);
			XMLOutputter xmlOut = new XMLOutputter();
			xmlOut.output(doc, out);
			out.flush();
			out.close();
		} catch (IOException e) {
			System.err.println(e);
		}
		
	} //}}}
	
	//{{{ txtRead
	Song txtRead(File fileIn) {
		String in = null;
		
		try {
			FileInputStream fi = new FileInputStream(fileIn);
			BufferedReader br = new BufferedReader(new InputStreamReader(fi));
			StringBuffer contents = new StringBuffer();
			String line = "";
			while((line = br.readLine()) != null) {
				contents.append(line);
				contents.append("\n");
			}
			br.close();
			in = contents.toString();
		} catch (Exception e) {
			e.printStackTrace();
		}
		Song newSong = new Song();
		
		java.lang.StringBuffer sb = new StringBuffer(in);
		int titleEnd = sb.indexOf("\n");
		int artistEnd = sb.indexOf("\n\n", titleEnd);
		newSong.setTitle(sb.substring(0, titleEnd));
		newSong.setArtist(sb.substring(titleEnd+1, artistEnd));
		newSong.setLyrics(sb.substring(artistEnd+2, sb.length()-1));
		
		return newSong;
	} //}}}
	
	//{{{ txtWrite
	void txtWrite(File fileOut, Song song) {
		String out = song.toString();
		try {
			FileOutputStream fo = new FileOutputStream(fileOut);
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fo));
			bw.write(out);
			bw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	} //}}}
	
	Properties loadProps(File fileIn) {
		Properties props = new Properties();
		try {
			FileInputStream in = new FileInputStream(fileIn);
			props.load(in);
			in.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return props;
	}
	
	void saveProps(Properties props, File fileOut) {
		try {
			FileOutputStream out = new FileOutputStream(fileOut);
			props.store(out, "---No Comment---");
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
