package org.landis.jlyrics;

//{{{ Imports
import javax.swing.UIManager;
import javax.swing.JFrame;
import java.awt.event.WindowAdapter;
import java.io.File;
import java.awt.event.WindowEvent;
import java.util.Properties;
import javax.swing.SwingUtilities;
import org.landis.jlyrics.*;
import javax.swing.JOptionPane; //}}}

public class jLyrics {
	
	//{{{ variables
	private boolean dirty;
	private String look = "javax.swing.plaf.metal.MetalLookAndFeel";
	MainWindow mainWindow = new MainWindow(this); //}}}
	
	//{{{ jLyrics()
	public jLyrics() {
		loadProps();
		try {
			switchLookAndFeel(look);
		} catch(Exception e) { }
		initMain();
	} //}}}
	
	//{{{ switchLookAndFeel()
	public void switchLookAndFeel(int i) {
		try {
			if (i == -1) {
				UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
			}
			else {
				look = UIManager.getInstalledLookAndFeels()[i].getClassName();
				UIManager.setLookAndFeel(look);
			}
			SwingUtilities.updateComponentTreeUI(mainWindow);
			mainWindow.pack();
		} catch(Exception e) {}
	} //}}}
	
	//{{{ switchLookAndFeel()
	public void switchLookAndFeel(String laf) {
		try {
			UIManager.setLookAndFeel(laf);
			SwingUtilities.updateComponentTreeUI(mainWindow);
			mainWindow.pack();
		} catch(Exception e) {}
	} //}}}
	
	//{{{ getFrame()
	public JFrame getFrame() {
		return mainWindow;
	}// }}}
	
	//{{{ getThis
	public jLyrics getController() {
		return this;
	} //}}}
	
	//{{{ setDirty()
	public void setDirty(boolean b) {
		dirty = b;
	}//}}}
	
	//{{{ checkForDirty()
	public void checkForDirty() {
		boolean cancel = false;
		if (dirty) {
			int saveNow = JOptionPane.showConfirmDialog(mainWindow, "Your songs have changed.\nDo you want to save now?",
				"Save Now?", JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
			if (saveNow == JOptionPane.YES_OPTION) {
				mainWindow.saveData();
			} else if (saveNow == JOptionPane.CANCEL_OPTION) {
				cancel = true;
			}

		}
		if ( cancel != true ) {
			System.exit(0);
		}
	} //}}}
	
	//{{{ initMain()
	private void initMain() {
		mainWindow.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		mainWindow.pack();
		mainWindow.setVisible(true);
		mainWindow.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				saveProps();
				checkForDirty();
			}
		});
	} //}}}
	
	private void loadProps() {
		FileIO fileIn = new FileIO();
		Properties myProps = fileIn.loadProps(new File(System.getProperty("user.home") + "/.props"));
		look = myProps.getProperty("LookAndFeel");
	}
	
	private void saveProps() {
		FileIO fileOut = new FileIO();
		Properties myProps = new Properties();
		myProps.put("LookAndFeel", look);
		fileOut.saveProps(myProps, new File(System.getProperty("user.home") + "/.props"));
	}
}
