/* Changed June 17, 2003 by Brad Landis
 * to better work for my program
 */

 /*
 * Song.java
 *
 * Copyright (c) 2002 Michael Rex <me@rexi.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

package org.landis.jlyrics.song;


import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.Toolkit;
/**
 * This class encapsulates the information of a song.
 * @author Michael Rex
 * @version 0.1
 */
public class Song implements Comparable
{
	public static final int INVALID_INDEX = -1;
	
	private String lyrics;
	private String title;
	private String artist;
	private int index;

	/**
	 * Creates a new instance without initializing the objects contents.
	 */
	public Song()
	{
		lyrics = title = artist = "";
		index = INVALID_INDEX;
	}

	/**
	 * Returns the song's artist.
	 * @return 
	 */
	public String getArtist()
	{
		return artist;
	}

	/**
	 *
	 */
	public void setArtist(String in)
	{
		artist = in;
	}

	/**
	 *
	 */
	public String getTitle()
	{
		return title;
	}

	/**
	 *
	 */
	public void setTitle(String in)
	{
		title = in;
	}

	/**
	 *
	 */
	public String getLyrics()
	{
		return lyrics;
	}

	/**
	 *
	 */
	public void setLyrics(String in)
	{
		lyrics = in;
	}

	/**
	 *
	 */
	public int getIndex()
	{
		return index;
	}

	/**
	 *
	 */
	public void setIndex(int i)
	{
		index = i;
	}

	/**
	 *
	 */
	public String toString()
	{
		return title + "\n" + artist + "\n\n" + lyrics;
	}
	
	public boolean equals(Object o)
	{
		if (!(o instanceof Song))
			return false;
		Song n = (Song) o;
		return n.title.equals(title) && n.artist.equals(artist) && n.lyrics.equals(lyrics);
	}
	
	public int hashCode()
	{
		return 31*title.hashCode() + artist.hashCode() + lyrics.hashCode();
	}
	
	public int compareTo(Object o)
	{
		int r;
		Song n = (Song) o;
		int lastCmp = title.toLowerCase().compareTo(n.title.toLowerCase());
		if (lastCmp!=0)
			r = lastCmp;
		else 
			r = artist.toLowerCase().compareTo(n.artist.toLowerCase());
		return r;
	}

	/**  Work on copying later
	 *   
	 */
	
	/*private void clipboardMethods(String action, String text)
	{
		SecurityManager security = System.getSecurityManager();
		try {
			if (security != null) {
				security.checkSystemClipboardAccess();
			}
			Clipboard clipboard = java.awt.Toolkit.getDefaultToolkit().getSystemClipboard();
			clipboard.setContents( new Song(), clipboard);
		} catch ( SecurityException se ) {
			System.err.println("Security Exception:  " + se);
		} catch ( java.awt.HeadlessException he ) {
			System.err.println("Headless Exception: " + he);
		}
	}*/

	public void copy()
	{
		Clipboard clip = java.awt.Toolkit.getDefaultToolkit().getSystemClipboard();
		clip.setContents(new StringSelection(toString()), null);
	}

	/**
	 * Parses a node and fills the objects attributes with the appropriate data.
	 * @param node the node to extract data from
	 */
/*	private void parseNode(Node node)
	{
		NodeList nl = node.getChildNodes();
		Node curnode = null;
		
		for(int i = 0; i < nl.getLength(); ++i)
		{
			curnode = nl.item(i);

			if(curnode.getNodeName().equals(DomManager.TAG_ARTIST))
				artist = getNodeData(curnode);
			else if(curnode.getNodeName().equals(DomManager.TAG_TITLE))
				title = getNodeData(curnode);
			else if(curnode.getNodeName().equals(DomManager.TAG_LYRICS))
				lyrics = getNodeData(curnode);
		}
	}
	*/
	/**
	 * Returns the value stored in a node.
	 * If the node contains no value an empty string ist returned.
	 * @param node the node whose value should be returned
	 * @return the node's value or an empty string of it has no value
	 */
	/*private String getNodeData(Node node)
	{
		try
		{
			return node.getChildNodes().item(0).getNodeValue();
		}
		catch(NullPointerException e)
		{
			// if a node contains no data, return an empty string
			return "";
		}
	}
	*/
}
